

chrome.runtime.onMessage.addListener((message, sender, sendResponse) => {
  
  if (message.type === 'extractDataPfms') {
      const bootboxBodyElement = document.querySelector('#ctl00_ctl00_cphBody_cphBody_voucherN');
      const bodyText=bootboxBodyElement.textContent || bootboxBodyElement.innerText;
      const lgdTable=document.querySelector('.bkg.fullw');
      console.log("lgd table");
      var lgdCode;
      const allTdsLgdTable=lgdTable.querySelectorAll('td');
      console.log(allTdsLgdTable);
      if(allTdsLgdTable[1]){
          const LgdTextTableIn=allTdsLgdTable[1].textContent.trim();
          const regex = /Agency Unique Code: (\w+)/;
          const matchLgd = LgdTextTableIn.match(regex);
          if(matchLgd && matchLgd[1]){
              lgdCode=matchLgd[1];
              console.log(lgdCode);
          }else{
              console.log("Lgd code not found form pmfs .html");
          }
      }
      console.log(bodyText);
      const voucherNumberMatch = bodyText;
      if (voucherNumberMatch && lgdCode.length>0) {
          const voucherNumber = voucherNumberMatch.trim();
          console.log('Extracted Voucher Number:', voucherNumber);
          chrome.runtime.sendMessage({ type: 'pmfs_voucher_extracted' ,data:voucherNumber,lgd_code:lgdCode});
      }else{
        console.log("Voucher no or LGD code not found in the pmfs.html");
      }
    
  }
});




// extractData.js

// Listen for messages from the background script
chrome.runtime.onMessage.addListener((message, sender, sendResponse) => {
  if (message.type === 'data_pmfs_extract') {
    // Extract data from the source website
    
    var extractedData = [];
    const dataObj = [];
    const lgdTable=document.querySelector('.bkg.fullw');
    console.log("lgd table");
    var lgdCode;
    const allTdsLgdTable=lgdTable.querySelectorAll('td');
    if(allTdsLgdTable[1]){
        const LgdTextTableIn=allTdsLgdTable[1].textContent.trim();
        const regex = /Agency Unique Code: (\w+)/;
        const matchLgd = LgdTextTableIn.match(regex);
        if(matchLgd && matchLgd[1]){
            lgdCode=matchLgd[1];
            console.log(lgdCode);
        }else{
            console.log("Lgd code not found form pmfs extract");
        }
    }
    const modaltable = document.querySelector('#ctl00_ctl00_cphBody_cphBody_gvDigitallySignedFile');
    const selectElement = document.querySelector('#ctl00_ctl00_cphBody_cphBody_ddlScheme');
    const selectedOption = selectElement.options[selectElement.selectedIndex];
    console.log("options");
    console.log(selectElement.options);

    const selectedText = selectedOption.text;
    const match = selectedText.match(/- (.+)$/);
    console.log(match);
    console.log(selectedText);
    var selectedScheme;
    if (match && match[1]) {
        selectedScheme = match[1].trim();
        console.log("SELECTED SCHEME IS ",selectedScheme); // Outputs: "UP-Swachh Bharat Mission Gramin (9151)"
    } else {
        console.log("Pattern not found");
    }

    console.log(selectedText);
    console.log(selectElement);

    if (modaltable && selectedScheme && lgdCode.length>0 ) {

        const heading = modaltable.querySelector('tbody tr');
        const rows = modaltable.querySelectorAll('tbody tr');
        console.log("heading is "+heading);
        console.log("rows  is");
        console.log(rows);

        const headingcells = heading.querySelectorAll('th');
        console.log("headingcells  is ");
        console.log(headingcells);

        headingarr = [];
        headingcells.forEach(cell => {
            console.log(cell.textContent.trim());
            headingarr.push(cell.textContent.trim());
        });

        console.log("length os rows array"+rows.length);
        rows.forEach((row,index1) => {
            if(index1==0){
              return;
            }
            const rowcells = row.querySelectorAll("td");
            tempObj={};
            rowcells.forEach((cell,index) => {
                tempObj[headingarr[index]] = cell.textContent.trim();
            });
            dataObj.push(tempObj);
        });

        extractedData = dataObj;
        console.log("extractedData=",extractedData);
        console.log("Last scheme selectedc"+selectedScheme);
        console.log("LGD CODE is "+lgdCode);
        if(selectedScheme=="UP-Swachh Bharat Mission Gramin (9151)" || selectedScheme=="UP- RASHTRIYA GRAM SWARAJ ABHIYAN(RGSA) 3617"){
            chrome.runtime.sendMessage({ type: 'dataPfmsExtractExtracted', data: extractedData ,scheme:selectedScheme,lgdCode:lgdCode});
        }else{
            console.log("SELECTED scheme is different");
        }

    } else {
        console.log('Table not found.');
    }


    
    // Send the extracted data to the background script
    
  }
});
