// extractData.js

// Listen for messages from the background script
chrome.runtime.onMessage.addListener((message, sender, sendResponse) => {
  if (message.type === 'extractData') {
    // Extract data from the source website
    
    var extractedData = [];
    const dataObj = [];
    const modaltable = document.querySelector('body span#fileDetailsSpan table');
    const profileTable=document.querySelector("#gp-profile");
    console.log(profileTable);
    var lgd_code;
    const profileTds=profileTable.querySelectorAll("td");
    if(profileTds[3]){
      const profileCont=profileTds[3].textContent.trim();
      const splitProfileCont=profileCont.split("(");
      console.log(splitProfileCont);
      if(splitProfileCont[1]){
        lgd_code=splitProfileCont[1].trim().split(")")[0];
        console.log(lgd_code);
      }
    }else{
      lgd_code="";
      console.log("profile content not found");
    }
    console.log(profileTds[3].textContent.trim());
    console.log("Len of lgd_code",lgd_code.length);

    if (modaltable && lgd_code.length>0) {

        const heading = modaltable.querySelector('tbody tr');
        const rows = modaltable.querySelectorAll('tbody tr');

        const headingcells = heading.querySelectorAll('th');

        headingarr = [];
        headingcells.forEach(cell => {
            console.log(cell.textContent.trim());
            headingarr.push(cell.textContent.trim());
        });


        rows.forEach((row,index1) => {
            if(index1==0){
              return;
            }
            const rowcells = row.querySelectorAll("td");
            tempObj={};
            rowcells.forEach((cell,index) => {
                tempObj[headingarr[index]] = cell.textContent.trim();
            });
            dataObj.push(tempObj);
        });

        extractedData = dataObj;

    } else {
        console.log('Table not found.');
    }

    console.log("extractedData=",extractedData);
    
    // Send the extracted data to the background script
    chrome.runtime.sendMessage({ type: 'dataExtracted', data: extractedData,lgd_code:lgd_code });
  }
});

chrome.runtime.onMessage.addListener((message, sender, sendResponse) => {
  
  if (message.type === 'extractDataEgram') {
    const bootboxBodyElement = document.querySelector('.bootbox-body');
    const bodyText=bootboxBodyElement.textContent || bootboxBodyElement.innerText;
    const voucherNumberMatch = bodyText.match(/Voucher Number : (.+?) (?:saved|freezed) successfully/);
    const profileTable=document.querySelector("#gp-profile");
    console.log(profileTable);
    var lgd_code;
    const profileTds=profileTable.querySelectorAll("td");
    if(profileTds[3]){
      const profileCont=profileTds[3].textContent.trim();
      const splitProfileCont=profileCont.split("(");
      console.log(splitProfileCont);
      if(splitProfileCont[1]){
        lgd_code=splitProfileCont[1].trim().split(")")[0];
        console.log(lgd_code);
      }
    }else{
      lgd_code="";
      console.log("profile content not found");
    }
    console.log(profileTds[3].textContent.trim());
    if (voucherNumberMatch && voucherNumberMatch[1]) {
        const voucherNumber = voucherNumberMatch[1].trim();
        console.log('Extracted Voucher Number:', voucherNumber);
        chrome.runtime.sendMessage({ type: 'egram_voucher_extracted' ,data:voucherNumber,lgd_code:lgd_code});
    }
  }
});



