function selectScehme( value, formIndex ){
  var optionSelected = null;
  var select = null;
  var intvlID = setInterval(function(){
    select = document.getElementById(`incidence_type_${formIndex}`);
    console.log(select.options.length);
    for (const option of select.options) {
        if (option.getAttribute('data') === value) {
            optionSelected = option;
        }
        clearInterval(intvlID);
    }
    
    if (optionSelected) {
        optionSelected.selected = true;
        select.dispatchEvent(new Event('change'));
        console.log(optionSelected);
    } else {
        console.log('Option not found.');
    }
  }, 100);
}




// Listen for messages from the background script
chrome.runtime.onMessage.addListener((message, sender, sendResponse) => {
  if (message.type === 'pasteData') {

    console.log("pastedData=",message.data);
    console.log("LGD code=",message.lgd_code);

    message.data.forEach((row,index) => {
      if(index==0){
        return
      }
      document.getElementById('add_row').click();
    });

    message.data.forEach((row,index) => {
      const formIndex = index + 1;
      const [scheme] = row["Voucher Number"].split("/");
      console.log("Extracted scheme in Egram");
      console.log(scheme);
      selectScehme(scheme,formIndex);
      document.getElementById(`incidence_lat_${formIndex}`).value = row["Voucher Number"];
      document.getElementById(`solve_in_sec_${formIndex}`).value = row["Amount"];
      document.getElementById(`sender_imei_${formIndex}`).value = row["Vendor Name"];
      document.getElementById(`incidence_comment_${formIndex}`).value = row["Account No"];
      document.getElementById('come_from').value = 'extension';
      document.getElementById(`lgd_code`).value = message.lgd_code;
    });

  }
});

function injectButton(site, voucherNo,lgd_code) {
  // Create the button element
  const button = document.createElement('button');
  button.textContent = 'Click Here Voucher';
  button.id = 'egramVoucherButton';
  button.dataset.site = site; // Use dataset for custom attributes
  button.dataset.voucher = voucherNo; // Use dataset for custom attributes
  button.dataset.lgd_code = lgd_code; // Use dataset for custom attributes
  button.style.display = 'none'; // Initially hide the button

  // Append the button to the document body
  document.body.appendChild(button);

  // Add event listener to the button
  button.addEventListener('click', () => {
    console.log("Button clicked");
    console.log("Site:", button.dataset.site);
    console.log("Voucher Number:", button.dataset.voucher);
    console.log("lgd_code:", button.dataset.lgd_code);
    // Add your code here to handle the button click event
  });

  return button;
}
var voucherNo=null;
var button = null;
chrome.runtime.onMessage.addListener((message, sender, sendResponse) => {
  if (message.type === 'pasteVoucherEgram') {
    

    // Check if the button already exists
    if (!button && !voucherNo) {
      button = injectButton(message.site, message.data,message.lgd_code);
      voucherNo=message.data;
      console.log("Message received in sendVoucherEgram "+message.data+" "+message.site);
      document.getElementById('egramVoucherButton').click();
    }else{
      console.log("voucher already saved.."+voucherNo);
    }
  }
});
